<?php class WPUEF_Configurator
{
	public function __construct()
	{
	}
	public function render_page()
	{
		global $wpuef_option_model, $wpuef_user_model, $wpuef_woocommerce_is_active, $wpuef_buddypress_is_active;
		$fields_json_string = $wpuef_option_model->get_option('json_fields_string', false);
		
		wp_enqueue_style('wpuef-vendor',  WPUEF_PLUGIN_PATH.'/css/vendor.css');
		wp_enqueue_style('wpuef-formbuilder',  WPUEF_PLUGIN_PATH.'/css/formbuilder.css');
		wp_enqueue_style('wpuef-configurator',  WPUEF_PLUGIN_PATH.'/css/wpuef-configurator.css');
		
		wp_enqueue_script( 'wpuef-vendor', WPUEF_PLUGIN_PATH.'/js/vendor.js', array( 'jquery' ));
		wp_register_script( 'wpuef-configurator', WPUEF_PLUGIN_PATH.'/js/wpuef-configurator.js', array( 'jquery' ));
		
		wp_register_script( 'wpuef-formbuilder', WPUEF_PLUGIN_PATH.'/js/formbuilder.js', array( 'jquery' ));
		$js_options = array(
			'roles' => $wpuef_user_model->get_roles(),
			'woocommerce_is_active' => $wpuef_woocommerce_is_active ? 'true':'false',
			'buddypress_is_active' => $wpuef_buddypress_is_active ? 'true':'false',
			'fields_json_string' => $fields_json_string != "" ? stripslashes($fields_json_string) : "",
		);
		wp_localize_script( 'wpuef-formbuilder', 'wpuef_values', $js_options );
		wp_localize_script( 'wpuef-configurator', 'wpuef_values', $js_options );
		
		wp_enqueue_script( 'wpuef-formbuilder' );
		wp_enqueue_script( 'wpuef-configurator' );
		?>
		<div class="wrap">
			<h2><?php esc_html_e('Extra fields configuration', 'wp-user-extra-fields');?></h2>
			<div id="white-box">
				<div id='formbuilder'></div>
			</div>
		</div>		
		<?php 
	}
}
?>