<?php 
class WPUEF_UsersTable
{
	public function __construct()
	{
		add_filter( 'manage_users_columns', array(&$this,'add_column') );
		add_filter( 'manage_customers_columns', array(&$this,'add_column') );
		
		add_filter( 'manage_users_custom_column', array(&$this,'insert_colum_data'), 10, 3 );
		add_filter( 'manage_customers_custom_column', array(&$this,'insert_colum_data'), 10, 3 );
		
		add_filter( 'manage_users_sortable_columns',  array(&$this,'make_column_sortable'));
		
		add_action( 'pre_user_query', array(&$this,'sort_by_extra_fields'), 9 );

	}
	
	function add_column( $columns ) 
	{
		global $wpuef_option_model;
		$extra_fields = $wpuef_option_model->get_option('json_fields_string');
		if($extra_fields)
			foreach($extra_fields->fields as $extra_field)
				if( isset($extra_field->add_field_to_user_table_colum) && ($extra_field->add_field_to_user_table_colum))
				{
					$columns['wpuef_'.$extra_field->cid] = $extra_field->label;
				}
	
		return $columns;
	}
	function insert_colum_data( $val, $column_name, $user_id ) {
		//$user = get_userdata( $user_id );
		global $wpuef_option_model,$wpuef_shortcodes;
		$extra_fields = $wpuef_option_model->get_option('json_fields_string');
		
		if($extra_fields)
			foreach($extra_fields->fields as $extra_field)
				if($column_name == 'wpuef_'.$extra_field->cid)
					return $wpuef_shortcodes->wpuef_show_field_value(array('user_id' => $user_id, 'field_id' =>$extra_field->cid));
						
		return $val;
	}
	function make_column_sortable( $columns ) 
	{
		global $wpuef_option_model;
		$extra_fields = $wpuef_option_model->get_option('json_fields_string');
		if($extra_fields)
			foreach($extra_fields->fields as $extra_field)
				if( isset($extra_field->add_field_to_user_table_colum) && ($extra_field->add_field_to_user_table_colum))
				{
					if($extra_field->field_type != "country_and_state" && 
						$extra_field->field_type != 'title_no_input' && 
						$extra_field->field_type != 'checkboxes' && 
						$extra_field->field_type != 'paragraph' && 
						$extra_field->field_type != 'file' && 
						$extra_field->field_type != 'radio'  )
					$columns['wpuef_'.$extra_field->cid] = 'wpuef_cid_'.$extra_field->cid;
				}
	 
		return $columns;
	}
	public function add_extra_search_box()
	{
		wp_enqueue_style( 'wpuef-admin-user-table',  WPUEF_PLUGIN_PATH.'/css/wpuef-admin-user-table.css' );
		wp_enqueue_script( 'wpuef-backend-user-table',  WPUEF_PLUGIN_PATH.'/js/wpuef-backend-user-table.js' );
		?>
		<div class="wpuef-search-box">
			<input id="wpuef-search-input" name="wpuef_extra_field_search" value="" type="text">
			<input id="wpuef-search-submit" class="button" value="<?php esc_html_e('Search user by extra field', 'wp-user-extra-fields') ?>" type="submit">
		</div>
		<?php 
	}
	function sort_by_extra_fields( $query )  
	{
		global $wpuef_option_model, $wpdb;
		
		if( ! is_admin() || !isset($wpuef_option_model) || !isset($wpdb))
			return $query;
	
		$orderby = $query->get( 'orderby');
		$extra_fields = $wpuef_option_model->get_option('json_fields_string');
		
		//Order user list according exra field value
		 if($extra_fields)
			foreach($extra_fields->fields as $extra_field)
				if( isset($extra_field->add_field_to_user_table_colum) && ($extra_field->add_field_to_user_table_colum))
				{
					if( 'wpuef_cid_'.$extra_field->cid == $orderby )  
					{
						$query->query_from .= " LEFT JOIN $wpdb->usermeta AS wpuef_metavalue ON ($wpdb->users.ID = wpuef_metavalue.user_id) ";
						$query->query_where .= " AND (wpuef_metavalue.meta_key = 'wpuef_cid_".$extra_field->cid."' OR wpuef_metavalue.meta_value is NULL) ";
						$query->query_orderby = " ORDER BY ISNULL(wpuef_metavalue.meta_value), wpuef_metavalue.meta_value ".$query->query_vars["order"]."";
					
					}
				} 
		
		return $query;
		
		// Moved into the search_by_extra_fields() method
		
		if ( isset($_REQUEST['wpuef_extra_field_search']) && $_REQUEST['wpuef_extra_field_search'] != "")
		{
			
			$search_query = trim( $_REQUEST['wpuef_extra_field_search'], '*' );
			if ( $_REQUEST['wpuef_extra_field_search'] == $search_query )
			{
				global $wpuef_field_model,$wpuef_user_model, $wpdb;
				$field_data = $wpuef_field_model->get_all_fields_data();
				
				if(isset($field_data))
				{
					$search_by = array();
					$already_and = false;
					$first_run = true;
					$end_where = "";
					$custom_query = array('relation' => 'OR');
					//$qv = &$query->query_vars;
					foreach($field_data->fields as $field)
					{
						
						
						 $custom_query[] = 
							  array(
								'key' => "wpuef_cid_".$field->cid,
								'compare' => 'LIKE',
								 'value' => $search_query
						  ); 
					}

					
					$query->query_vars['meta_query'][] =  $custom_query;
					
				}
			}
		}
		
		return $query;
	}
	function search_by_extra_fields($query)
	{
		global $wpuef_field_model,$wpuef_user_model, $wpdb, $pagenow;
		$field_data = $wpuef_field_model->get_all_fields_data();
		if($pagenow !='users.php' || !isset($_REQUEST['s']) || $_REQUEST['s'] == "")
			return;
		
		$search_query = trim($_REQUEST['s'], '*' );
		$custom_query = array('relation' => 'OR');
		$qv = &$query->query_vars;
		if(isset($field_data))
		{
			foreach($field_data->fields as $field)
			{
				$custom_query[] = 
								  array(
									'key' => "wpuef_cid_".$field->cid,
									'compare' => 'LIKE',
									 'value' => $search_query
							  ); 
			}
			
			$qv['meta_query'][] = $custom_query;
		
		}
	
	}
}
?>