<?php class WPUEF_HtmlHelper
{
	var $extra_fields_custom_from_rendered_at_least_one_time = false;
	public function __construct()
	{
		
	}
	//BuddyPress 
	public function buddypress_profile_extra_field_values_table($user_id = null)
	{
		global $wpuef_option_model, $wpuef_shortcodes;
		$extra_fields = $wpuef_option_model->get_option('json_fields_string');
		$user_id = !isset($user_id) ? get_current_user_id() : $user_id;
		
		wp_enqueue_style('wpuef-buddypress-profile-fields-table', WPUEF_PLUGIN_PATH.'/css/wpuef-buddypress-profile-fields-table.css'); 
		
		if(file_exists ( get_theme_file_path()."/wpuef/buddypress_profile_extra_field_values_table.php" ))
			include get_theme_file_path()."/wpuef/buddypress_profile_extra_field_values_table.php";
		else
			include WPUEF_PLUGIN_ABS_PATH.'/templates/buddypress_profile_extra_field_values_table.php';
	}
	//WP, BuddyPress & WooCommerce Register form
	public function render_register_form_extra_fields()
	{
		global $wpuef_option_model, $wpuef_wpml_helper;
		wp_enqueue_style('wpuef-datepicker-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.css');   
		wp_enqueue_style('wpuef-datepicker-date-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.date.css');   
		wp_enqueue_style('wpuef-datepicker-time-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.time.css');  
		wp_enqueue_style('wpuef-common-styles', WPUEF_PLUGIN_PATH.'/css/wpuef-common-html-styles.css'); 
		if(strpos($_SERVER['REQUEST_URI'],"wp-login.php?action=register") !== false)
			wp_enqueue_style('wpuef-admin-any-register-form', WPUEF_PLUGIN_PATH.'/css/wpuef-admin-any-register-form.css'); 
		else 
			wp_enqueue_style('wpuef-admin-any-register-form', WPUEF_PLUGIN_PATH.'/css/wpuef-admin-any-register-form-divi.css'); 
		
		wp_enqueue_script('wpuef-ui-picker', WPUEF_PLUGIN_PATH.'/js/picker.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-ui-datepicker', WPUEF_PLUGIN_PATH.'/js/picker.date.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-ui-timepicker', WPUEF_PLUGIN_PATH.'/js/picker.time.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-file-uploader', WPUEF_PLUGIN_PATH.'/js/wpuef-file-uploader.js', array( 'jquery' ));
		wp_register_script('wpuef-file-manager', WPUEF_PLUGIN_PATH.'/js/wpuef-file-manager.js', array( 'jquery' ));
		wp_register_script('wpuef-registration-fields-check', WPUEF_PLUGIN_PATH.'/js/wpuef-registration-fields-check.js', array( 'jquery' ));
		$js_options = array('ajax_url' => admin_url( 'admin-ajax.php' ), 
							'remove_special_chars_from_file_name' => $wpuef_option_model->remove_special_chars_from_file_name() ? 'true' : 'false',
							'delete_pending_message' => "",
							'delete_popup_warning_message' => "",
							'file_check_popup_browser' => esc_html__("Please upgrade your browser, because your current browser lacks some new features we need!", 'wp-user-extra-fields'),  
							'file_check_popup_size' => esc_html__("Choosen file is too big and will not be uploaded!", 'wp-user-extra-fields'), 
							'file_check_popup_api' => esc_html__("The File APIs are not fully supported in this browser.", 'wp-user-extra-fields'),
							'required_fields_error' => esc_html__("Required fields cannot be left empty.", 'wp-user-extra-fields'),
							'please_wait_message' => esc_html__('Saving data, please wait...', 'wp-user-extra-fields'),
							'done_saving_message' => esc_html__('Done!', 'wp-user-extra-fields'),
							'error_saving_message' => esc_html__('There was an error saving data. Please retry or contact the site admin.', 'wp-user-extra-fields'),
							'num_field_min_max_error' => esc_html__("Please insert a valid number value.", 'wp-user-extra-fields'), 
							'num_field_min_text' => esc_html__("Min:", 'wp-user-extra-fields'),
							'num_field_max_text' => esc_html__("Max:", 'wp-user-extra-fields'),
							'date_format' => $wpuef_option_model->get_date_format(),
							'max_year' => date('Y', strtotime('+10 years')),
							'security' => wp_create_nonce('wpuef_security_upload')
							
							);
		wp_localize_script( 'wpuef-file-manager', 'wpuef', $js_options);
		wp_localize_script( 'wpuef-registration-fields-check', 'wpuef', $js_options);
		wp_enqueue_script( 'wpuef-file-manager');
		wp_enqueue_script( 'wpuef-registration-fields-check');
		
		
		wp_enqueue_script('wpuef-common-validation', WPUEF_PLUGIN_PATH.'/js/wpuef-common-validation.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-backend-datetime-controller-init', WPUEF_PLUGIN_PATH.'/js/wpuef-backend-datetime-controller-init.js', array( 'jquery' ));

		//datepicker localization get_locale() 
		if(wpuef_url_exists(WPUEF_PLUGIN_PATH.'/js/time/translations/'.$wpuef_wpml_helper->get_current_language().'.js'))
			wp_enqueue_script('wpuef-timepicker-localization', WPUEF_PLUGIN_PATH.'/js/time/translations/'.$wpuef_wpml_helper->get_current_language().'.js');
	
		$extra_fields = $wpuef_option_model->get_option('json_fields_string');
		if($extra_fields)
		{
			if(file_exists ( get_theme_file_path()."/wpuef/any_register_form.php" ))
				include get_theme_file_path()."/wpuef/any_register_form.php";
			else
				include WPUEF_PLUGIN_ABS_PATH.'/templates/any_register_form.php';
		}
	}
	//BuddyPress Register form
	public function render_bp_register_form_extra_fields()
	{
		global $wpuef_option_model, $wpuef_wpml_helper;
		wp_enqueue_style('wpuef-datepicker-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.css');   
		wp_enqueue_style('wpuef-datepicker-date-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.date.css');   
		wp_enqueue_style('wpuef-datepicker-time-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.time.css');  
		wp_enqueue_style('wpuef-common-styles', WPUEF_PLUGIN_PATH.'/css/wpuef-common-html-styles.css'); 
		if(strpos($_SERVER['REQUEST_URI'],"wp-login.php?action=register") !== false)
			wp_enqueue_style('wpuef-admin-bp-register-form', WPUEF_PLUGIN_PATH.'/css/wpuef-admin-bp-register-form.css'); 

		wp_enqueue_script('wpuef-ui-picker', WPUEF_PLUGIN_PATH.'/js/picker.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-ui-datepicker', WPUEF_PLUGIN_PATH.'/js/picker.date.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-ui-timepicker', WPUEF_PLUGIN_PATH.'/js/picker.time.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-file-uploader', WPUEF_PLUGIN_PATH.'/js/wpuef-file-uploader.js', array( 'jquery' ));
		wp_register_script('wpuef-file-manager', WPUEF_PLUGIN_PATH.'/js/wpuef-file-manager.js', array( 'jquery' ));
		wp_register_script('wpuef-backend-datetime-controller-init', WPUEF_PLUGIN_PATH.'/js/wpuef-backend-datetime-controller-init.js', array( 'jquery' ));
		$js_options = array('ajax_url' => admin_url( 'admin-ajax.php' ), 
							'remove_special_chars_from_file_name' => $wpuef_option_model->remove_special_chars_from_file_name() ? 'true' : 'false',
							'delete_pending_message' => "",
							'delete_popup_warning_message' => "",
							'file_check_popup_browser' => esc_html__("Please upgrade your browser, because your current browser lacks some new features we need!", 'wp-user-extra-fields'),  
							'file_check_popup_size' => esc_html__("Choosen file is too big and will not be uploaded!", 'wp-user-extra-fields'), 
							'file_check_popup_api' => esc_html__("The File APIs are not fully supported in this browser.", 'wp-user-extra-fields'),
							'required_fields_error' => esc_html__("Required fields cannot be left empty.", 'wp-user-extra-fields'),
							'please_wait_message' => esc_html__('Saving data, please wait...', 'wp-user-extra-fields'),
							'done_saving_message' => esc_html__('Done!', 'wp-user-extra-fields'),
							'error_saving_message' => esc_html__('There was an error saving data. Please retry or contact the site admin.', 'wp-user-extra-fields'),
							'num_field_min_max_error' => esc_html__("Please insert a valid number value.", 'wp-user-extra-fields'), 
							'num_field_min_text' => esc_html__("Min:", 'wp-user-extra-fields'),
							'num_field_max_text' => esc_html__("Max:", 'wp-user-extra-fields'),
							'date_format' => $wpuef_option_model->get_date_format(),
							'max_year' => date('Y', strtotime('+10 years')	),
							'security' => wp_create_nonce('wpuef_security_upload')							
							);
		wp_localize_script( 'wpuef-file-manager', 'wpuef', $js_options);
		wp_localize_script( 'wpuef-backend-datetime-controller-init', 'wpuef', $js_options);
		wp_enqueue_script( 'wpuef-backend-datetime-controller-init');
		wp_enqueue_script( 'wpuef-file-manager');
		
		wp_enqueue_script('wpuef-registration-fields-check', WPUEF_PLUGIN_PATH.'/js/wpuef-registration-fields-check.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-common-validation', WPUEF_PLUGIN_PATH.'/js/wpuef-common-validation.js', array( 'jquery' ));
		

		//datepicker localization get_locale() 
		if(wpuef_url_exists(WPUEF_PLUGIN_PATH.'/js/time/translations/'.$wpuef_wpml_helper->get_current_language().'.js'))
			wp_enqueue_script('wpuef-timepicker-localization', WPUEF_PLUGIN_PATH.'/js/time/translations/'.$wpuef_wpml_helper->get_current_language().'.js');
	
		$extra_fields = $wpuef_option_model->get_option('json_fields_string');
		if($extra_fields)
		{
			if(file_exists ( get_theme_file_path()."/wpuef/bp_register_form.php" ))
				include get_theme_file_path()."/wpuef/bp_register_form.php";
			else
				include WPUEF_PLUGIN_ABS_PATH.'/templates/bp_register_form.php';
		}
	}
	public function render_register_form_extra_fields_wccm()
	{
		global $wpuef_option_model, $wpuef_wpml_helper;
		wp_enqueue_style('wpuef-datepicker-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.css');   
		wp_enqueue_style('wpuef-datepicker-date-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.date.css');   
		wp_enqueue_style('wpuef-datepicker-time-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.time.css');  
		wp_enqueue_style('wpuef-common-styles', WPUEF_PLUGIN_PATH.'/css/wpuef-common-html-styles.css'); 

		wp_enqueue_script('wpuef-ui-picker', WPUEF_PLUGIN_PATH.'/js/picker.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-ui-datepicker', WPUEF_PLUGIN_PATH.'/js/picker.date.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-ui-timepicker', WPUEF_PLUGIN_PATH.'/js/picker.time.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-file-uploader', WPUEF_PLUGIN_PATH.'/js/wpuef-file-uploader.js', array( 'jquery' ));
		wp_register_script('wpuef-file-manager', WPUEF_PLUGIN_PATH.'/js/wpuef-file-manager.js', array( 'jquery' ));
		wp_register_script('wpuef-backend-datetime-controller-init', WPUEF_PLUGIN_PATH.'/js/wpuef-backend-datetime-controller-init.js', array( 'jquery' ));
		$js_options = array('ajax_url' => admin_url( 'admin-ajax.php' ), 
							'remove_special_chars_from_file_name' => $wpuef_option_model->remove_special_chars_from_file_name() ? 'true' : 'false',
							'delete_pending_message' => "",
							'delete_popup_warning_message' => "",
							'file_check_popup_browser' => esc_html__("Please upgrade your browser, because your current browser lacks some new features we need!", 'wp-user-extra-fields'),  
							'file_check_popup_size' => esc_html__("Choosen file is too big and will not be uploaded!", 'wp-user-extra-fields'), 
							'file_check_popup_api' => esc_html__("The File APIs are not fully supported in this browser.", 'wp-user-extra-fields'),
							'required_fields_error' => esc_html__("Required fields cannot be left empty.", 'wp-user-extra-fields'),
							'please_wait_message' => esc_html__('Saving data, please wait...', 'wp-user-extra-fields'),
							'done_saving_message' => esc_html__('Done!', 'wp-user-extra-fields'),
							'error_saving_message' => esc_html__('There was an error saving data. Please retry or contact the site admin.', 'wp-user-extra-fields'),
							'num_field_min_max_error' => esc_html__("Please insert a valid number value.", 'wp-user-extra-fields'), 
							'num_field_min_text' => esc_html__("Min:", 'wp-user-extra-fields'),
							'num_field_max_text' => esc_html__("Max:", 'wp-user-extra-fields'),
							'date_format' => $wpuef_option_model->get_date_format(),
							'max_year' => date('Y', strtotime('+10 years')),
							'security' => wp_create_nonce('wpuef_security_upload')					
							);
		wp_localize_script( 'wpuef-file-manager', 'wpuef',$js_options); 																	
		wp_localize_script( 'wpuef-backend-datetime-controller-init', 'wpuef',$js_options); 																	
		wp_enqueue_script( 'wpuef-file-manager');
		wp_enqueue_script( 'wpuef-backend-datetime-controller-init');
		wp_enqueue_script('wpuef-common-validation', WPUEF_PLUGIN_PATH.'/js/wpuef-common-validation.js', array( 'jquery' ));

		//datepicker localization get_locale() 
		if(wpuef_url_exists(WPUEF_PLUGIN_PATH.'/js/time/translations/'.$wpuef_wpml_helper->get_current_language().'.js'))
			wp_enqueue_script('wpuef-timepicker-localization', WPUEF_PLUGIN_PATH.'/js/time/translations/'.$wpuef_wpml_helper->get_current_language().'.js');
		
		$extra_fields = $wpuef_option_model->get_option('json_fields_string');
		if($extra_fields)
		{
			if(file_exists ( get_theme_file_path()."/wpuef/bp_register_form.php" ))
				include get_theme_file_path()."/wpuef/bp_register_form.php";
			else
				include WPUEF_PLUGIN_ABS_PATH.'/templates/bp_register_form.php';
		}
	}
	public function woocommerce_render_extra_fields_wccm($user_id = null)
	{
		//$edit_page_type: 0 my account, 1 billing address edit, 2 shipping address edit
		global $wpuef_option_model, $wpuef_user_model;
		wp_enqueue_style('wpuef-common-styles', WPUEF_PLUGIN_PATH.'/css/wpuef-common-html-styles.css'); 
		$extra_fields = $wpuef_option_model->get_option('json_fields_string');
		if($extra_fields)
		{
			if(file_exists ( get_theme_file_path()."/wpuef/wccm_extra_fields.php" ))
				include get_theme_file_path()."/wpuef/wccm_extra_fields.php";
			else
				include WPUEF_PLUGIN_ABS_PATH.'/templates/wccm_extra_fields.php'; 
		}
		
	}
	//WP Add new user
	function render_add_table_with_extra_fields()
	{
		$this->render_edit_table_with_extra_fields(null, false, true);
	}
	//WP Edit my account page (admin & frontend and WCCM Edit user)
	function render_edit_table_with_extra_fields($user_id = null, $is_buddypress = false, $is_new_user = false)
	{
		global $wpuef_option_model, $wpuef_user_model, $wpuef_wpml_helper;
		wp_enqueue_style('wpuef-datepicker-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.css');   
		wp_enqueue_style('wpuef-datepicker-date-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.date.css');   
		wp_enqueue_style('wpuef-datepicker-time-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.time.css');  
		wp_enqueue_style('wpuef-common-styles', WPUEF_PLUGIN_PATH.'/css/wpuef-common-html-styles.css'); 

		wp_enqueue_script('wpuef-ui-picker', WPUEF_PLUGIN_PATH.'/js/picker.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-ui-datepicker', WPUEF_PLUGIN_PATH.'/js/picker.date.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-ui-timepicker', WPUEF_PLUGIN_PATH.'/js/picker.time.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-file-uploader', WPUEF_PLUGIN_PATH.'/js/wpuef-file-uploader.js', array( 'jquery' ));
		wp_register_script('wpuef-file-manager', WPUEF_PLUGIN_PATH.'/js/wpuef-file-manager.js', array( 'jquery' ));
		wp_register_script('wpuef-backend-datetime-controller-init', WPUEF_PLUGIN_PATH.'/js/wpuef-backend-datetime-controller-init.js', array( 'jquery' ));
		$js_options = array('ajax_url' => admin_url( 'admin-ajax.php' ), 
							'remove_special_chars_from_file_name' => $wpuef_option_model->remove_special_chars_from_file_name() ? 'true' : 'false',
							'delete_pending_message' => "",
							'delete_popup_warning_message' => "",
							'file_check_popup_browser' => esc_html__("Please upgrade your browser, because your current browser lacks some new features we need!", 'wp-user-extra-fields'),  
							'file_check_popup_size' => esc_html__("Choosen file is too big and will not be uploaded!", 'wp-user-extra-fields'), 
							'file_check_popup_api' => esc_html__("The File APIs are not fully supported in this browser.", 'wp-user-extra-fields'),
							'required_fields_error' => esc_html__("Required fields cannot be left empty.", 'wp-user-extra-fields'),
							'please_wait_message' => esc_html__('Saving data, please wait...', 'wp-user-extra-fields'),
							'done_saving_message' => esc_html__('Done!', 'wp-user-extra-fields'),
							'error_saving_message' => esc_html__('There was an error saving data. Please retry or contact the site admin.', 'wp-user-extra-fields'),
							'num_field_min_max_error' => esc_html__("Please insert a valid number value.", 'wp-user-extra-fields'), 
							'num_field_min_text' => esc_html__("Min:", 'wp-user-extra-fields'),
							'num_field_max_text' => esc_html__("Max:", 'wp-user-extra-fields'),
							'date_format' => $wpuef_option_model->get_date_format(),
							'max_year' => date('Y', strtotime('+10 years')),
							'security' => wp_create_nonce('wpuef_security_upload')					
							);
		wp_localize_script( 'wpuef-file-manager', 'wpuef', $js_options);
		wp_localize_script( 'wpuef-backend-datetime-controller-init', 'wpuef', $js_options);
		wp_enqueue_script( 'wpuef-file-manager');
		wp_enqueue_script( 'wpuef-backend-datetime-controller-init');
		wp_enqueue_script('wpuef-common-validation', WPUEF_PLUGIN_PATH.'/js/wpuef-common-validation.js', array( 'jquery' ));
		//datepicker localization get_locale() 
		if(wpuef_url_exists(WPUEF_PLUGIN_PATH.'/js/time/translations/'.$wpuef_wpml_helper->get_current_language().'.js'))
			wp_enqueue_script('wpuef-timepicker-localization', WPUEF_PLUGIN_PATH.'/js/time/translations/'.$wpuef_wpml_helper->get_current_language().'.js');

		$extra_fields = $wpuef_option_model->get_option('json_fields_string');
		if($extra_fields)
		{
			if(file_exists ( get_theme_file_path()."/wpuef/wp_wccm_my_account.php" ))
				include get_theme_file_path()."/wpuef/wp_wccm_my_account.php";
			else
				include WPUEF_PLUGIN_ABS_PATH.'/templates/wp_wccm_my_account.php';
		}
	}
	//BuddyPress edit profile
	function render_bp_edit_table_with_extra_fields($user_id = null, $is_buddypress = false, $is_new_user = false)
	{
		global $wpuef_option_model, $wpuef_user_model, $wpuef_wpml_helper;
		wp_enqueue_style('wpuef-datepicker-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.css');   
		wp_enqueue_style('wpuef-datepicker-date-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.date.css');   
		wp_enqueue_style('wpuef-datepicker-time-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.time.css');  
		wp_enqueue_style('wpuef-common-styles', WPUEF_PLUGIN_PATH.'/css/wpuef-common-html-styles.css'); 

		wp_enqueue_script('wpuef-ui-picker', WPUEF_PLUGIN_PATH.'/js/picker.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-ui-datepicker', WPUEF_PLUGIN_PATH.'/js/picker.date.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-ui-timepicker', WPUEF_PLUGIN_PATH.'/js/picker.time.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-file-uploader', WPUEF_PLUGIN_PATH.'/js/wpuef-file-uploader.js', array( 'jquery' ));
		wp_register_script('wpuef-file-manager', WPUEF_PLUGIN_PATH.'/js/wpuef-file-manager.js', array( 'jquery' ));
		wp_register_script('wpuef-backend-datetime-controller-init', WPUEF_PLUGIN_PATH.'/js/wpuef-backend-datetime-controller-init.js', array( 'jquery' ));
		$js_options = array('ajax_url' => admin_url( 'admin-ajax.php' ), 
							'remove_special_chars_from_file_name' => $wpuef_option_model->remove_special_chars_from_file_name() ? 'true' : 'false',
							'delete_pending_message' => "",
							'delete_popup_warning_message' => "",
							'file_check_popup_browser' => esc_html__("Please upgrade your browser, because your current browser lacks some new features we need!", 'wp-user-extra-fields'),  
							'file_check_popup_size' => esc_html__("Choosen file is too big and will not be uploaded!", 'wp-user-extra-fields'), 
							'file_check_popup_api' => esc_html__("The File APIs are not fully supported in this browser.", 'wp-user-extra-fields'),
							'required_fields_error' => esc_html__("Required fields cannot be left empty.", 'wp-user-extra-fields'),
							'please_wait_message' => esc_html__('Saving data, please wait...', 'wp-user-extra-fields'),
							'done_saving_message' => esc_html__('Done!', 'wp-user-extra-fields'),
							'error_saving_message' => esc_html__('There was an error saving data. Please retry or contact the site admin.', 'wp-user-extra-fields'),
							'num_field_min_max_error' => esc_html__("Please insert a valid number value.", 'wp-user-extra-fields'), 
							'num_field_min_text' => esc_html__("Min:", 'wp-user-extra-fields'),
							'num_field_max_text' => esc_html__("Max:", 'wp-user-extra-fields'),
							'date_format' => $wpuef_option_model->get_date_format(),
							'max_year' => date('Y', strtotime('+10 years')),
							'security' => wp_create_nonce('wpuef_security_upload')					
							);
		wp_localize_script( 'wpuef-file-manager', 'wpuef', $js_options);
		wp_localize_script( 'wpuef-backend-datetime-controller-init', 'wpuef', $js_options);
		wp_enqueue_script( 'wpuef-file-manager');
		wp_enqueue_script( 'wpuef-backend-datetime-controller-init');
		
		wp_enqueue_script('wpuef-common-validation', WPUEF_PLUGIN_PATH.'/js/wpuef-common-validation.js', array( 'jquery' ));
		
		
		//datepicker localization get_locale() 
		if(wpuef_url_exists(WPUEF_PLUGIN_PATH.'/js/time/translations/'.$wpuef_wpml_helper->get_current_language().'.js'))
			wp_enqueue_script('wpuef-timepicker-localization', WPUEF_PLUGIN_PATH.'/js/time/translations/'.$wpuef_wpml_helper->get_current_language().'.js');

		$extra_fields = $wpuef_option_model->get_option('json_fields_string');
		if($extra_fields)
		{
			if(file_exists ( get_theme_file_path()."/wpuef/bp_edit_profile.php" ))
				include get_theme_file_path()."/wpuef/bp_edit_profile.php";
			else
				include WPUEF_PLUGIN_ABS_PATH.'/templates/bp_edit_profile.php';
		}
	}
	//Custom extra fields form rendered by shortcode
	function render_extra_fields_custom_form($field_ids, $user_id = null)
	{
		global $wpuef_option_model, $wpuef_user_model, $wpuef_wpml_helper;
		wp_enqueue_style('wpuef-datepicker-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.css');   
		wp_enqueue_style('wpuef-datepicker-date-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.date.css');   
		wp_enqueue_style('wpuef-datepicker-time-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.time.css');  
		wp_enqueue_style('wpuef-common-styles', WPUEF_PLUGIN_PATH.'/css/wpuef-common-html-styles.css'); 
		wp_enqueue_style('wpuef-extra-fields-custom-form', WPUEF_PLUGIN_PATH.'/css/wpuef-extra-fields-custom-form.css'); 
		wp_enqueue_style('wpuef-common-styles', WPUEF_PLUGIN_PATH.'/css/wpuef-common-html-styles.css');
		
		wp_enqueue_script('wpuef-ui-picker', WPUEF_PLUGIN_PATH.'/js/picker.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-ui-datepicker', WPUEF_PLUGIN_PATH.'/js/picker.date.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-ui-timepicker', WPUEF_PLUGIN_PATH.'/js/picker.time.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-file-uploader', WPUEF_PLUGIN_PATH.'/js/wpuef-file-uploader.js', array( 'jquery' ));
		wp_register_script('wpuef-frontend-extra-fields-custom-form-ui', WPUEF_PLUGIN_PATH.'/js/wpuef-frontend-extra-fields-custom-form-ui.js', array( 'jquery' ));
		wp_register_script('wpuef-file-manager', WPUEF_PLUGIN_PATH.'/js/wpuef-file-manager.js', array( 'jquery' ));
		wp_register_script('wpuef-frontend-extra-fields-custom-form', WPUEF_PLUGIN_PATH.'/js/wpuef-frontend-extra-fields-custom-form.js', array( 'jquery' ));
		wp_register_script('wpuef-backend-datetime-controller-init', WPUEF_PLUGIN_PATH.'/js/wpuef-backend-datetime-controller-init.js', array( 'jquery' ));
		$js_options = array('ajax_url' => admin_url( 'admin-ajax.php' ), 
							'remove_special_chars_from_file_name' => $wpuef_option_model->remove_special_chars_from_file_name() ? 'true' : 'false',
							'delete_pending_message' => "",
							'delete_popup_warning_message' => "",
							'file_check_popup_browser' => esc_html__("Please upgrade your browser, because your current browser lacks some new features we need!", 'wp-user-extra-fields'),  
							'file_check_popup_size' => esc_html__("Choosen file is too big and will not be uploaded!", 'wp-user-extra-fields'), 
							'file_check_popup_api' => esc_html__("The File APIs are not fully supported in this browser.", 'wp-user-extra-fields'),
							'required_fields_error' => esc_html__("Required fields cannot be left empty.", 'wp-user-extra-fields'),
							'please_wait_message' => esc_html__('Saving data, please wait...', 'wp-user-extra-fields'),
							'done_saving_message' => esc_html__('Done!', 'wp-user-extra-fields'),
							'error_saving_message' => esc_html__('There was an error saving data. Please retry or contact the site admin.', 'wp-user-extra-fields'),
							'num_field_min_max_error' => esc_html__("Please insert a valid number value.", 'wp-user-extra-fields'), 
							'num_field_min_text' => esc_html__("Min:", 'wp-user-extra-fields'),
							'num_field_max_text' => esc_html__("Max:", 'wp-user-extra-fields'),
							'date_format' => $wpuef_option_model->get_date_format(),
							'max_year' => date('Y', strtotime('+10 years')),
							'security' => wp_create_nonce('wpuef_security_upload')					
							);
		wp_localize_script( 'wpuef-file-manager', 'wpuef',  $js_options);
		wp_localize_script( 'wpuef-frontend-extra-fields-custom-form', 'wpuef',  $js_options);
		wp_localize_script( 'wpuef-frontend-extra-fields-custom-form-ui', 'wpuef',  $js_options);
		wp_localize_script( 'wpuef-backend-datetime-controller-init', 'wpuef',  $js_options);
		wp_enqueue_script( 'wpuef-frontend-extra-fields-custom-form');
		wp_enqueue_script( 'wpuef-frontend-extra-fields-custom-form-ui');
		wp_enqueue_script( 'wpuef-file-manager');
		wp_enqueue_script( 'wpuef-backend-datetime-controller-init');
		
		
		
		wp_enqueue_script('wpuef-common-validation', WPUEF_PLUGIN_PATH.'/js/wpuef-common-validation.js', array( 'jquery' ));
		
		
		//datepicker localization get_locale() 
		if(wpuef_url_exists(WPUEF_PLUGIN_PATH.'/js/time/translations/'.$wpuef_wpml_helper->get_current_language().'.js'))
			wp_enqueue_script('wpuef-timepicker-localization', WPUEF_PLUGIN_PATH.'/js/time/translations/'.$wpuef_wpml_helper->get_current_language().'.js');


		$extra_fields = $wpuef_option_model->get_option('json_fields_string');
		$fields_ids = !is_array($field_ids) ? array($field_ids) : $field_ids;
		
		if($extra_fields)
		{
			if(file_exists ( get_theme_file_path()."/wpuef/shortcode_custom_form.php" ))
				include get_theme_file_path()."/wpuef/shortcode_custom_form.php";
			else
				include WPUEF_PLUGIN_ABS_PATH.'/templates/shortcode_custom_form.php';
		}
	}
	//WooCommerce Edit my account page - account details, shipping address or billing address edit page (frontend)
	function woocommerce_render_edit_form_extra_fields($user_id = null, $render_form = false, $edit_page_type = 0)
	{
		//$edit_page_type: 0 my account, 1 billing address edit, 2 shipping address edit
		
		global $wpuef_option_model, $wpuef_user_model, $wpuef_wpml_helper;
		wp_enqueue_style('wpuef-datepicker-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.css');   
		wp_enqueue_style('wpuef-datepicker-date-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.date.css');   
		wp_enqueue_style('wpuef-datepicker-time-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.time.css');  
		wp_enqueue_style('wpuef-common-styles', WPUEF_PLUGIN_PATH.'/css/wpuef-common-html-styles.css'); 
		wp_enqueue_style('wpuef-admin-woocommerce-my-account', WPUEF_PLUGIN_PATH.'/css/wpuef-admin-woocommerce-my-account.css'); 

		wp_enqueue_script('wpuef-ui-picker', WPUEF_PLUGIN_PATH.'/js/picker.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-ui-datepicker', WPUEF_PLUGIN_PATH.'/js/picker.date.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-ui-timepicker', WPUEF_PLUGIN_PATH.'/js/picker.time.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-file-uploader', WPUEF_PLUGIN_PATH.'/js/wpuef-file-uploader.js', array( 'jquery' ));
		wp_register_script('wpuef-file-manager', WPUEF_PLUGIN_PATH.'/js/wpuef-file-manager.js', array( 'jquery' ));
		wp_register_script('wpuef-backend-datetime-controller-init', WPUEF_PLUGIN_PATH.'/js/wpuef-backend-datetime-controller-init.js', array( 'jquery' ));
		$js_options = array('ajax_url' => admin_url( 'admin-ajax.php' ), 
							'remove_special_chars_from_file_name' => $wpuef_option_model->remove_special_chars_from_file_name() ? 'true' : 'false',
							'delete_pending_message' => "",
							'delete_popup_warning_message' => "",
							'file_check_popup_browser' => esc_html__("Please upgrade your browser, because your current browser lacks some new features we need!", 'wp-user-extra-fields'),  
							'file_check_popup_size' => esc_html__("Choosen file is too big and will not be uploaded!", 'wp-user-extra-fields'), 
							'file_check_popup_api' => esc_html__("The File APIs are not fully supported in this browser.", 'wp-user-extra-fields'),
							'required_fields_error' => esc_html__("Required fields cannot be left empty.", 'wp-user-extra-fields'),
							'please_wait_message' => esc_html__('Saving data, please wait...', 'wp-user-extra-fields'),
							'done_saving_message' => esc_html__('Done!', 'wp-user-extra-fields'),
							'error_saving_message' => esc_html__('There was an error saving data. Please retry or contact the site admin.', 'wp-user-extra-fields'),
							'num_field_min_max_error' => esc_html__("Please insert a valid number value.", 'wp-user-extra-fields'), 
							'num_field_min_text' => esc_html__("Min:", 'wp-user-extra-fields'),
							'num_field_max_text' => esc_html__("Max:", 'wp-user-extra-fields'),
							'date_format' => $wpuef_option_model->get_date_format(),
							'max_year' => date('Y', strtotime('+10 years')),
							'security' => wp_create_nonce('wpuef_security_upload')					
							);
		wp_localize_script( 'wpuef-file-manager', 'wpuef',$js_options);
		wp_localize_script( 'wpuef-backend-datetime-controller-init', 'wpuef', $js_options);
		wp_enqueue_script( 'wpuef-file-manager');
		wp_enqueue_script( 'wpuef-backend-datetime-controller-init');
		wp_enqueue_script('wpuef-common-validation', WPUEF_PLUGIN_PATH.'/js/wpuef-common-validation.js', array( 'jquery' ));

		//datepicker localization get_locale() 
		if(wpuef_url_exists(WPUEF_PLUGIN_PATH.'/js/time/translations/'.$wpuef_wpml_helper->get_current_language().'.js'))
			wp_enqueue_script('wpuef-timepicker-localization', WPUEF_PLUGIN_PATH.'/js/time/translations/'.$wpuef_wpml_helper->get_current_language().'.js');

		$extra_fields = $wpuef_option_model->get_option('json_fields_string');
		if($extra_fields)
		{
			if(file_exists ( get_theme_file_path()."/wpuef/woocommerce_my_account.php" ))
				include get_theme_file_path()."/wpuef/woocommerce_my_account.php";
			else
				include WPUEF_PLUGIN_ABS_PATH.'/templates/woocommerce_my_account.php';
		}
		
	}
	//WooCommerce Checkout page
	function woocommerce_render_checkout_form_extra_fields($user_id = null)
	{
		global $wpuef_option_model, $wpuef_user_model, $wpuef_wpml_helper, $wpuef_woocommerce_is_active;
		wp_enqueue_style('wpuef-datepicker-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.css');   
		wp_enqueue_style('wpuef-datepicker-date-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.date.css');   
		wp_enqueue_style('wpuef-datepicker-time-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.time.css');  
		wp_enqueue_style('wpuef-common-styles', WPUEF_PLUGIN_PATH.'/css/wpuef-common-html-styles.css'); 

		wp_enqueue_script('wpuef-ui-picker', WPUEF_PLUGIN_PATH.'/js/picker.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-ui-datepicker', WPUEF_PLUGIN_PATH.'/js/picker.date.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-ui-timepicker', WPUEF_PLUGIN_PATH.'/js/picker.time.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-file-uploader', WPUEF_PLUGIN_PATH.'/js/wpuef-file-uploader.js', array( 'jquery' ));
		wp_register_script('wpuef-file-manager', WPUEF_PLUGIN_PATH.'/js/wpuef-file-manager.js', array( 'jquery' ));
		wp_register_script('wpuef-backend-datetime-controller-init', WPUEF_PLUGIN_PATH.'/js/wpuef-backend-datetime-controller-init.js', array( 'jquery' ));
		$js_options = array('ajax_url' => admin_url( 'admin-ajax.php' ), 
							'remove_special_chars_from_file_name' => $wpuef_option_model->remove_special_chars_from_file_name() ? 'true' : 'false',
							'delete_pending_message' => "",
							'delete_popup_warning_message' => "",
							'file_check_popup_browser' => esc_html__("Please upgrade your browser, because your current browser lacks some new features we need!", 'wp-user-extra-fields'),  
							'file_check_popup_size' => esc_html__("Choosen file is too big and will not be uploaded!", 'wp-user-extra-fields'), 
							'file_check_popup_api' => esc_html__("The File APIs are not fully supported in this browser.", 'wp-user-extra-fields'),
							'required_fields_error' => esc_html__("Required fields cannot be left empty.", 'wp-user-extra-fields'),
							'please_wait_message' => esc_html__('Saving data, please wait...', 'wp-user-extra-fields'),
							'done_saving_message' => esc_html__('Done!', 'wp-user-extra-fields'),
							'error_saving_message' => esc_html__('There was an error saving data. Please retry or contact the site admin.', 'wp-user-extra-fields'),
							'num_field_min_max_error' => esc_html__("Please insert a valid number value.", 'wp-user-extra-fields'), 
							'num_field_min_text' => esc_html__("Min:", 'wp-user-extra-fields'),
							'num_field_max_text' => esc_html__("Max:", 'wp-user-extra-fields'),
							'date_format' => $wpuef_option_model->get_date_format(),
							'max_year' => date('Y', strtotime('+10 years'))	,
							'security' => wp_create_nonce('wpuef_security_upload')				
							);
		wp_localize_script( 'wpuef-backend-datetime-controller-init', 'wpuef', $js_options);
		wp_localize_script( 'wpuef-file-manager', 'wpuef', $js_options);
		wp_enqueue_script( 'wpuef-file-manager');
		wp_enqueue_script( 'wpuef-backend-datetime-controller-init');
		wp_enqueue_script('wpuef-common-validation', WPUEF_PLUGIN_PATH.'/js/wpuef-common-validation.js', array( 'jquery' ));

		//datepicker localization get_locale() 
		if(wpuef_url_exists(WPUEF_PLUGIN_PATH.'/js/time/translations/'.$wpuef_wpml_helper->get_current_language().'.js'))
			wp_enqueue_script('wpuef-timepicker-localization', WPUEF_PLUGIN_PATH.'/js/time/translations/'.$wpuef_wpml_helper->get_current_language().'.js');

		$extra_fields = $wpuef_option_model->get_option('json_fields_string');
		if($extra_fields)
		{
			if(file_exists ( get_theme_file_path()."/wpuef/woocommerce_checkout_form.php" ))
				include get_theme_file_path()."/wpuef/woocommerce_checkout_form.php";
			else
				include WPUEF_PLUGIN_ABS_PATH.'/templates/woocommerce_checkout_form.php';
		}
		
	}
	//WooCommerce Order details meta box addon (backend)
	function woocommerce_render_order_edit_form_extra_fields($user_id = null)
	{
		global $wpuef_option_model, $wpuef_user_model, $wpuef_wpml_helper;
		
		wp_enqueue_style('wpuef-datepicker-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.css');   
		wp_enqueue_style('wpuef-datepicker-date-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.date.css');   
		wp_enqueue_style('wpuef-datepicker-time-classic', WPUEF_PLUGIN_PATH.'/css/datepicker/default.time.css');  
		wp_enqueue_style('wpuef-common-styles', WPUEF_PLUGIN_PATH.'/css/wpuef-common-html-styles.css'); 
		wp_enqueue_style('wpuef-order-edit', WPUEF_PLUGIN_PATH.'/css/wpuef-admin-order-details.css'); 

		wp_enqueue_script('wpuef-ui-picker', WPUEF_PLUGIN_PATH.'/js/picker.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-ui-datepicker', WPUEF_PLUGIN_PATH.'/js/picker.date.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-ui-timepicker', WPUEF_PLUGIN_PATH.'/js/picker.time.js', array( 'jquery' ));
		wp_enqueue_script('wpuef-file-uploader', WPUEF_PLUGIN_PATH.'/js/wpuef-file-uploader.js', array( 'jquery' ));
		wp_register_script('wpuef-file-manager', WPUEF_PLUGIN_PATH.'/js/wpuef-file-manager.js', array( 'jquery' ));
		wp_register_script('wpuef-backend-datetime-controller-init', WPUEF_PLUGIN_PATH.'/js/wpuef-backend-datetime-controller-init.js', array( 'jquery' ));
		$js_options = array('ajax_url' => admin_url( 'admin-ajax.php' ), 
							'remove_special_chars_from_file_name' => $wpuef_option_model->remove_special_chars_from_file_name() ? 'true' : 'false',
							'delete_pending_message' => "",
							'delete_popup_warning_message' => "",
							'file_check_popup_browser' => esc_html__("Please upgrade your browser, because your current browser lacks some new features we need!", 'wp-user-extra-fields'),  
							'file_check_popup_size' => esc_html__("Choosen file is too big and will not be uploaded!", 'wp-user-extra-fields'), 
							'file_check_popup_api' => esc_html__("The File APIs are not fully supported in this browser.", 'wp-user-extra-fields'),
							'required_fields_error' => esc_html__("Required fields cannot be left empty.", 'wp-user-extra-fields'),
							'please_wait_message' => esc_html__('Saving data, please wait...', 'wp-user-extra-fields'),
							'done_saving_message' => esc_html__('Done!', 'wp-user-extra-fields'),
							'error_saving_message' => esc_html__('There was an error saving data. Please retry or contact the site admin.', 'wp-user-extra-fields'),
							'num_field_min_max_error' => esc_html__("Please insert a valid number value.", 'wp-user-extra-fields'), 
							'num_field_min_text' => esc_html__("Min:", 'wp-user-extra-fields'),
							'num_field_max_text' => esc_html__("Max:", 'wp-user-extra-fields'),
							'date_format' => $wpuef_option_model->get_date_format(),
							'max_year' => date('Y', strtotime('+10 years')),
							'security' => wp_create_nonce('wpuef_security_upload')					
							);
		wp_localize_script( 'wpuef-file-manager', 'wpuef', $js_options);
		wp_localize_script( 'wpuef-backend-datetime-controller-init', 'wpuef', $js_options);
		wp_enqueue_script( 'wpuef-file-manager');
		wp_enqueue_script( 'wpuef-backend-datetime-controller-init');
		//datepicker localization get_locale() 
		if(wpuef_url_exists(WPUEF_PLUGIN_PATH.'/js/time/translations/'.$wpuef_wpml_helper->get_current_language().'.js'))
			wp_enqueue_script('wpuef-timepicker-localization', WPUEF_PLUGIN_PATH.'/js/time/translations/'.$wpuef_wpml_helper->get_current_language().'.js');

		$extra_fields = $wpuef_option_model->get_option('json_fields_string');
		if($extra_fields)
		{
			if(file_exists ( get_theme_file_path()."/wpuef/woocommerce_order_edit_form.php" ))
				include get_theme_file_path()."/wpuef/woocommerce_order_edit_form.php";
			else
				include WPUEF_PLUGIN_ABS_PATH.'/templates/woocommerce_order_edit_form.php';
		}
		
	}
	//WP new user registration notification email sent to admin
	function wp_new_user_registration_notification($user_id)
	{
		global $wpuef_option_model, $wpuef_user_model;
		$extra_fields = $wpuef_option_model->get_option('json_fields_string');
		if($extra_fields)
		{
			if(file_exists ( get_theme_file_path()."/wpuef/email_new_user_registration.php" ))
				include get_theme_file_path()."/wpuef/email_new_user_registration.php";
			else
				include WPUEF_PLUGIN_ABS_PATH.'/templates/email_new_user_registration.php';
		} 
	}
	//Woocommerce emails
	function woocommerce_render_fields_on_emails($user_id)
	{
		global $wpuef_option_model, $wpuef_user_model;
		$extra_fields = $wpuef_option_model->get_option('json_fields_string');
		if($extra_fields)
		{
			if(file_exists ( get_theme_file_path()."/wpuef/woocommerce_email.php" ))
				include get_theme_file_path()."/wpuef/woocommerce_email.php";
			else
				include WPUEF_PLUGIN_ABS_PATH.'/templates/woocommerce_email.php';
		} 
	}
}
?>